Clazz.declarePackage ("jalview.appletgui");
Clazz.load (["awt2swing.Panel", "java.awt.event.ActionListener", "awt2swing.Button", "$.ScrollPane", "$.TextArea", "java.awt.BorderLayout", "java.util.Vector"], "jalview.appletgui.PairwiseAlignPanel", ["jalview.analysis.AlignSeq", "jalview.appletgui.AlignFrame", "jalview.datamodel.Alignment", "jalview.util.Format", "$.MessageManager", "java.awt.Font"], function () {
c$ = Clazz.decorateAsClass (function () {
this.sequences = null;
this.ap = null;
this.scrollPane = null;
this.textarea = null;
this.viewInEditorButton = null;
this.jPanel1 = null;
this.borderLayout1 = null;
Clazz.instantialize (this, arguments);
}, jalview.appletgui, "PairwiseAlignPanel", awt2swing.Panel, java.awt.event.ActionListener);
Clazz.prepareFields (c$, function () {
this.sequences =  new java.util.Vector ();
this.scrollPane =  new awt2swing.ScrollPane ();
this.textarea =  new awt2swing.TextArea ();
this.viewInEditorButton =  new awt2swing.Button ();
this.jPanel1 =  new awt2swing.Panel ();
this.borderLayout1 =  new java.awt.BorderLayout ();
});
Clazz.makeConstructor (c$, 
function (ap) {
Clazz.superConstructor (this, jalview.appletgui.PairwiseAlignPanel, []);
try {
this.jbInit ();
} catch (e) {
if (Clazz.exceptionOf (e, Exception)) {
e.printStackTrace ();
} else {
throw e;
}
}
this.ap = ap;
this.sequences =  new java.util.Vector ();
var seqs;
var seqStrings = ap.av.getViewAsString (true);
if (ap.av.getSelectionGroup () == null) {
seqs = ap.av.getAlignment ().getSequencesArray ();
} else {
seqs = ap.av.getSelectionGroup ().getSequencesInOrder (ap.av.getAlignment ());
}var scores =  Clazz.newFloatArray (seqs.length, seqs.length, 0);
var totscore = 0;
var count = ap.av.getSelectionGroup ().getSize ();
var type = (ap.av.getAlignment ().isNucleotide ()) ? "dna" : "pep";
var seq;
for (var i = 1; i < count; i++) {
for (var j = 0; j < i; j++) {
var as =  new jalview.analysis.AlignSeq (seqs[i], seqStrings[i], seqs[j], seqStrings[j], type);
if (as.s1str.length == 0 || as.s2str.length == 0) {
continue;
}as.calcScoreMatrix ();
as.traceAlignment ();
as.printAlignment (System.out);
scores[i][j] = as.getMaxScore () / as.getASeq1 ().length;
totscore = totscore + scores[i][j];
this.textarea.append (as.getOutput ());
this.sequences.add (as.getAlignedSeq1 ());
this.sequences.add (as.getAlignedSeq1 ());
}
}
if (count > 2) {
System.out.println ("Pairwise alignment scaled similarity score matrix\n");
for (var i = 0; i < count; i++) {
jalview.util.Format.print (System.out, "%s \n", ("" + i) + " " + seqs[i].getName ());
}
System.out.println ("\n");
for (var i = 0; i < count; i++) {
for (var j = 0; j < i; j++) {
jalview.util.Format.printDouble (System.out, "%7.3f", scores[i][j] / totscore);
}
}
System.out.println ("\n");
}}, "jalview.appletgui.AlignmentPanel");
Clazz.overrideMethod (c$, "actionPerformed", 
function (evt) {
if (evt.getSource () === this.viewInEditorButton) {
this.viewInEditorButton_actionPerformed ();
}}, "java.awt.event.ActionEvent");
Clazz.defineMethod (c$, "viewInEditorButton_actionPerformed", 
function () {
var seq =  new Array (this.sequences.size ());
for (var i = 0; i < this.sequences.size (); i++) {
seq[i] = this.sequences.elementAt (i);
}
 new jalview.appletgui.AlignFrame ( new jalview.datamodel.Alignment (seq), this.ap.av.applet, "Pairwise Aligned Sequences", false);
});
Clazz.defineMethod (c$, "jbInit", 
($fz = function () {
this.setLayout (this.borderLayout1);
this.textarea.setFont ( new java.awt.Font ("Monospaced", 0, 12));
this.textarea.setText ("");
this.viewInEditorButton.setFont ( new java.awt.Font ("Verdana", 0, 12));
this.viewInEditorButton.setLabel (jalview.util.MessageManager.getString ("label.view_alignment_editor"));
this.viewInEditorButton.addActionListener (this);
this.add (this.scrollPane, "Center");
this.scrollPane.add (this.textarea);
this.add (this.jPanel1, "South");
this.jPanel1.add (this.viewInEditorButton, null);
}, $fz.isPrivate = true, $fz));
});
